//************************************************************************************
//**  
//**  File name:     \\MATRIXNAS\Product Information\Locktronics\CD ROM manuals and programs\Source files\LK8905 - Locktronics PIC program for PIC course\LK8905 Firmware.c
//**  Generated by:  Flowcode v4.3.7.63
//**  Date:          Thursday, January 15, 2015 09:18:53
//**  Licence:       Professional
//**  Registered to: JonnyW
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P18F2455
#define MX_EE
#define MX_EE_TYPE3
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_BCB
#define MX_SPI_SDI 0
#define MX_SPI_SDO 7
#define MX_SPI_SCK 1
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 0
#define MX_I2C_SCL 1
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1
#define MX_PWM_TRIS2a trisb
#define MX_PWM_2a 3

//Functions
#define MX_CLK_SPEED 48000000
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic18.h>
#endif

//Configuration data
#ifdef _BOOSTC
#pragma DATA 0x300000, 0x20
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x300001, 0xe
#endif
#ifdef _HI_TECH_C
__CONFIG(1, 0xe20);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300002, 0x3e
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x300003, 0x1e
#endif
#ifdef _HI_TECH_C
__CONFIG(2, 0x1e3e);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300004, 0x0
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x300005, 0x81
#endif
#ifdef _HI_TECH_C
__CONFIG(3, 0x8100);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300006, 0x81
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x300007, 0x0
#endif
#ifdef _HI_TECH_C
__CONFIG(4, 0x81);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300008, 0xf
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x300009, 0x80
#endif
#ifdef _HI_TECH_C
__CONFIG(5, 0x800f);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000a, 0xf
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000b, 0xa0
#endif
#ifdef _HI_TECH_C
__CONFIG(6, 0xa00f);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000c, 0xf
#endif
#ifdef _HI_TECH_C
//__CONFIG(, );
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000d, 0x0
#endif
#ifdef _HI_TECH_C
__CONFIG(7, 0xf);
#endif

//Internal functions
#include "C:\Program Files (x86)\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_3_AND();
void FCM_Car_Alarm();
void FCM_Motor();
void FCM_Programmable_Logic();
void FCM_Sequence_Generator();
void FCM_Thermistor();
void FCM_Timer();
void FCM_Waveform_Generator();
void FCM_Program_Mode();
void FCM_LED_Flash();


//Variable declarations
char FCV_D;
char FCV_B1;
char FCV_SWITCHES;
char FCV_B2;
char FCV_ANA;
char FCV_LIGHT;
char FCV_VAR;
char FCV_ANB;
char FCV_MASTER;
char FCV_OFFSET;
char FCV_MODE;
char FCV_SWITCH;
short FCV_SPEED;
char FCV_SWITCHES3;
char FCV_SWITCH1;
short FCV_TEMP;
char FCV_SWITCH2;
char FCV_COUNT;
char FCV_TEMP2;
char FCV_TEMP3;
char FCV_SPEED2;
char FCV_A;
char FCV_B;
char FCV_B0;
char FCV_C;

char FCLV_LOOP1;

//Defines:

/**** Macro Substitutions ****
0 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

void FCD_ADC0_SampleADC();
char FCD_ADC0_ReadAsByte();
short FCD_ADC0_ReadAsInt();
float FCD_ADC0_ReadAsVoltage();
void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
1 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(1): //Macro function declarations

void FCD_ADC1_SampleADC();
char FCD_ADC1_ReadAsByte();
short FCD_ADC1_ReadAsInt();
float FCD_ADC1_ReadAsVoltage();
void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
255 = Timer 2 Rollover Value
0x04 = Timer 2 Prescaler Value
%c = Unused
0 = Alternate Pin FCD_PWM0_Enable
******************************/




//PWM(0): //Macro function declarations

void FCD_PWM0_Enable(char nIdx);
void FCD_PWM0_Disable(char nIdx);
void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty);
void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal);
void FCD_PWM0_SetDutyCycle10bit(char nIdx, short nDuty);



//ADC(0): //Macro implementations


void FCD_ADC0_SampleADC()
{
	
	/*******Supported Devices******************************************************************
	// 18F2220, 18F2221, 18F2320, 18F2321, 18F24J10, 18F2410, 18F2420, 18F2423, 18F2450,
	// 18F2455, 18F2480, 18F25J10, 18F2510, 18F2515, 18F2520, 18F2523, 18F2525, 18F2550,
	// 18F2580, 18F2585, 18F2610, 18F2620, 18F2680, 18F4220, 18F4221, 18F4320, 18F4321,
	// 18F44J10, 18F4410, 18F4420, 18F4423, 18F4450, 18F4455, 18F4480, 18F45J10, 18F4510,
	// 18F4515, 18F4520, 18F4523, 18F4525, 18F4550, 18F4580, 18F4585, 18F4610, 18F4620,
	// 18F4680, 18F4682, 18F4685
	******************************************************************************************/

		#define MX_ADC_CHANNEL		0
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		0

		//set up ADC conversion
		char old_tris, cnt;
		adcon2 = MX_ADC_CONV_SP & 0x07;

		//find appropriate bit
		#if (MX_ADC_CHANNEL == 0)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x0E;
		#endif
		#if (MX_ADC_CHANNEL == 1)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x0D;
		#endif
		#if (MX_ADC_CHANNEL == 2)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x04
			adcon1 = 0x0C;
		#endif
		#if (MX_ADC_CHANNEL == 3)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x08
			adcon1 = 0x0B;
			#if (MX_ADC_VREF_OPT != 0)
				#ifdef _BOOSTC
					#pragma error "Target device is currently using AN3 for VREF+"
				#endif
				#ifdef HI_TECH_C
					#error Target device is currently using AN3 for VREF+
				#endif
			#endif
		#endif
		#if (MX_ADC_CHANNEL == 4)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x20
			adcon1 = 0x0A;
		#endif
		#if (MX_ADC_CHANNEL == 5)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x09;
		#endif
		#if (MX_ADC_CHANNEL == 6)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x08;
		#endif
		#if (MX_ADC_CHANNEL == 7)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x04
			adcon1 = 0x07;
		#endif
		#if (MX_ADC_CHANNEL == 8)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x06;
		#endif
		#if (MX_ADC_CHANNEL == 9)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x10
			adcon1 = 0x05;
		#endif
		#if (MX_ADC_CHANNEL == 10)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x04;
		#endif
		#if (MX_ADC_CHANNEL == 11)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x10
			adcon1 = 0x03;
		#endif
		#if (MX_ADC_CHANNEL == 12)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x02;
		#endif

		//sanity check
		#ifndef MX_ADC_TRIS_REG
			#ifdef _BOOSTC
				#pragma error "ADC Type 13 conversion code error - please contact technical support"
			#endif
			#ifdef HI_TECH_C
				#error ADC Type 13 conversion code error - please contact technical support
			#endif
		#endif

		//assign VREF functionality
		#if (MX_ADC_VREF_OPT != 0)
			st_bit(adcon1, VCFG0);
		#endif

		//store old tris value, and set the i/o pin as an input
		old_tris = MX_ADC_TRIS_REG;
		MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;

		//turn ADC on
		adcon0 = 0x01 | (MX_ADC_CHANNEL << 2);

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		adcon0 = adcon0 | 0x02;
		while (adcon0 & 0x02);

		//restore old tris value, and reset adc registers
		MX_ADC_TRIS_REG = old_tris;
		adcon1 = 0x0f;
		adcon0 = 0x00;

		#undef MX_ADC_TRIS_REG
		#undef MX_ADC_TRIS_MSK
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CHANNEL
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return adresh;

}

short FCD_ADC0_ReadAsInt()
{
	
		short iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (adresh << 2);
		iRetVal = iRetVal | (adresl >> 6);

		return (iRetVal);

}

float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		#ifdef _BOOSTC
			fVoltage = float32_from_int32(MX_ADC_VREF_V);					//Convert reference voltage count to floating point (0 - 500 x 10mV)
			fVoltage = float32_mul(fVoltage, 0.01);							//Convert reference voltage count to actual voltage (0 - 5)
			fVperDiv = float32_mul(fVoltage, 0.000976);						//Convert actual voltage to voltage per division (VRef / 1024)
			fSample = float32_from_int32(iSample);							//Convert to floating point variable
			fVoltage = float32_mul(fSample, fVperDiv);						//Calculate floating point voltage
		#endif

		#ifdef HI_TECH_C
			fVoltage = MX_ADC_VREF_V;										//Convert reference voltage count to floating point (0 - 500 x 10mV)
			fVoltage = fVoltage * 0.01;										//Convert reference voltage count to actual voltage (0 - 5)
			fVperDiv = fVoltage * 0.000976;									//Convert actual voltage to voltage per division (VRef / 1024)
			fSample = iSample;												//Convert to floating point variable
			fVoltage = fSample * fVperDiv;									//Calculate floating point voltage
		#endif

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//ADC(1): //Macro implementations


void FCD_ADC1_SampleADC()
{
	
	/*******Supported Devices******************************************************************
	// 18F2220, 18F2221, 18F2320, 18F2321, 18F24J10, 18F2410, 18F2420, 18F2423, 18F2450,
	// 18F2455, 18F2480, 18F25J10, 18F2510, 18F2515, 18F2520, 18F2523, 18F2525, 18F2550,
	// 18F2580, 18F2585, 18F2610, 18F2620, 18F2680, 18F4220, 18F4221, 18F4320, 18F4321,
	// 18F44J10, 18F4410, 18F4420, 18F4423, 18F4450, 18F4455, 18F4480, 18F45J10, 18F4510,
	// 18F4515, 18F4520, 18F4523, 18F4525, 18F4550, 18F4580, 18F4585, 18F4610, 18F4620,
	// 18F4680, 18F4682, 18F4685
	******************************************************************************************/

		#define MX_ADC_CHANNEL		1
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		0

		//set up ADC conversion
		char old_tris, cnt;
		adcon2 = MX_ADC_CONV_SP & 0x07;

		//find appropriate bit
		#if (MX_ADC_CHANNEL == 0)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x0E;
		#endif
		#if (MX_ADC_CHANNEL == 1)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x0D;
		#endif
		#if (MX_ADC_CHANNEL == 2)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x04
			adcon1 = 0x0C;
		#endif
		#if (MX_ADC_CHANNEL == 3)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x08
			adcon1 = 0x0B;
			#if (MX_ADC_VREF_OPT != 0)
				#ifdef _BOOSTC
					#pragma error "Target device is currently using AN3 for VREF+"
				#endif
				#ifdef HI_TECH_C
					#error Target device is currently using AN3 for VREF+
				#endif
			#endif
		#endif
		#if (MX_ADC_CHANNEL == 4)
			#define MX_ADC_TRIS_REG  trisa
			#define MX_ADC_TRIS_MSK  0x20
			adcon1 = 0x0A;
		#endif
		#if (MX_ADC_CHANNEL == 5)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x09;
		#endif
		#if (MX_ADC_CHANNEL == 6)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x08;
		#endif
		#if (MX_ADC_CHANNEL == 7)
			#define MX_ADC_TRIS_REG  trise
			#define MX_ADC_TRIS_MSK  0x04
			adcon1 = 0x07;
		#endif
		#if (MX_ADC_CHANNEL == 8)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x06;
		#endif
		#if (MX_ADC_CHANNEL == 9)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x10
			adcon1 = 0x05;
		#endif
		#if (MX_ADC_CHANNEL == 10)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x02
			adcon1 = 0x04;
		#endif
		#if (MX_ADC_CHANNEL == 11)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x10
			adcon1 = 0x03;
		#endif
		#if (MX_ADC_CHANNEL == 12)
			#define MX_ADC_TRIS_REG  trisb
			#define MX_ADC_TRIS_MSK  0x01
			adcon1 = 0x02;
		#endif

		//sanity check
		#ifndef MX_ADC_TRIS_REG
			#ifdef _BOOSTC
				#pragma error "ADC Type 13 conversion code error - please contact technical support"
			#endif
			#ifdef HI_TECH_C
				#error ADC Type 13 conversion code error - please contact technical support
			#endif
		#endif

		//assign VREF functionality
		#if (MX_ADC_VREF_OPT != 0)
			st_bit(adcon1, VCFG0);
		#endif

		//store old tris value, and set the i/o pin as an input
		old_tris = MX_ADC_TRIS_REG;
		MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;

		//turn ADC on
		adcon0 = 0x01 | (MX_ADC_CHANNEL << 2);

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		adcon0 = adcon0 | 0x02;
		while (adcon0 & 0x02);

		//restore old tris value, and reset adc registers
		MX_ADC_TRIS_REG = old_tris;
		adcon1 = 0x0f;
		adcon0 = 0x00;

		#undef MX_ADC_TRIS_REG
		#undef MX_ADC_TRIS_MSK
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CHANNEL
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

char FCD_ADC1_ReadAsByte()
{
	
		FCD_ADC1_SampleADC();

		return adresh;

}

short FCD_ADC1_ReadAsInt()
{
	
		short iRetVal;

		FCD_ADC1_SampleADC();

		iRetVal = (adresh << 2);
		iRetVal = iRetVal | (adresl >> 6);

		return (iRetVal);

}

float FCD_ADC1_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC1_ReadAsInt();											//Read as 10-bit Integer

		#ifdef _BOOSTC
			fVoltage = float32_from_int32(MX_ADC_VREF_V);					//Convert reference voltage count to floating point (0 - 500 x 10mV)
			fVoltage = float32_mul(fVoltage, 0.01);							//Convert reference voltage count to actual voltage (0 - 5)
			fVperDiv = float32_mul(fVoltage, 0.000976);						//Convert actual voltage to voltage per division (VRef / 1024)
			fSample = float32_from_int32(iSample);							//Convert to floating point variable
			fVoltage = float32_mul(fSample, fVperDiv);						//Calculate floating point voltage
		#endif

		#ifdef HI_TECH_C
			fVoltage = MX_ADC_VREF_V;										//Convert reference voltage count to floating point (0 - 500 x 10mV)
			fVoltage = fVoltage * 0.01;										//Convert reference voltage count to actual voltage (0 - 5)
			fVperDiv = fVoltage * 0.000976;									//Convert actual voltage to voltage per division (VRef / 1024)
			fSample = iSample;												//Convert to floating point variable
			fVoltage = fSample * fVperDiv;									//Calculate floating point voltage
		#endif

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC1_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//PWM(0): //Macro implementations


void FCD_PWM0_Enable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	  		#ifdef _BOOSTC
	  			#pragma error "This chip does not have PWM capability"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error This chip does not have PWM capability
			#endif
	  #else
	    #ifndef MX_PWM_CNT
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (no MX_PWM_CNT)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (no MX_PWM_CNT)
			#endif
	    #endif
	    #if (MX_PWM_CNT < 1)
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (MX_PWM_CNT < 1)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (MX_PWM_CNT < 1)
			#endif
	    #endif
	    #if (MX_PWM_CNT > 2)
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (MX_PWM_CNT > 2)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (MX_PWM_CNT > 2)
			#endif
	    #endif
	    #ifndef MX_PWM_TRIS1
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (no MX_PWM_TRIS1)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (no MX_PWM_TRIS1)
			#endif
	    #endif
	    #ifndef MX_PWM_1
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (no MX_PWM_1)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (no MX_PWM_1)
			#endif
	    #endif
	    #if (MX_PWM_CNT == 2)
	      #ifndef MX_PWM_TRIS2
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (no MX_PWM_TRIS2)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (no MX_PWM_TRIS2)
			#endif
	      #endif
	      #ifndef MX_PWM_2
	  		#ifdef _BOOSTC
	  			#pragma error "FCD file error (no MX_PWM_2)"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error FCD file error (no MX_PWM_2)
			#endif
	      #endif
	    #endif
	    #if (0 == 1)
	      #ifndef MX_PWM_TRIS1a
				#ifdef _BOOSTC
					#pragma error "PWM component error (using alternative, but no MX_PWM_TRIS1a)"
				#endif
				#ifdef HI_TECH_C
					#error PWM component error (using alternative, but no MX_PWM_TRIS1a)
				#endif
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_1a
				#ifdef _BOOSTC
					#pragma error "PWM component error (using alternative, but no MX_PWM_1a)"
				#endif
				#ifdef HI_TECH_C
					#error PWM component error (using alternative, but no MX_PWM_1a)
				#endif
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	    #if (0 == 2)
	      #ifndef MX_PWM_TRIS2a
				#ifdef _BOOSTC
					#pragma error "PWM component error (using alternative, but no MX_PWM_TRIS2a)"
				#endif
				#ifdef HI_TECH_C
					#error PWM component error (using alternative, but no MX_PWM_TRIS2a)
				#endif
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_2a
				#ifdef _BOOSTC
					#pragma error "PWM component error (using alternative, but no MX_PWM_2a)"
				#endif
				#ifdef HI_TECH_C
					#error PWM component error (using alternative, but no MX_PWM_2a)
				#endif
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	  #endif

	 #ifdef MX_PWM
	    pr2 = 255;
	    t2con = 0x04;

	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x0C;

	      #if (0 == 1)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS1a, MX_PWM_1a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS1, MX_PWM_1);
	      #endif
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x0C;
	      #if (0 == 2)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS2a, MX_PWM_2a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS2, MX_PWM_2);
	      #endif
	   }
	  #endif
	 #endif

	 #ifdef MX_PWM_ALT_ERROR
	   #undef MX_PWM_ALT_ERROR
	 #endif

}

void FCD_PWM0_Disable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	  		#ifdef _BOOSTC
	  			#pragma error "This chip does not have PWM capability"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error This chip does not have PWM capability
			#endif
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x00;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x00;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty)
{
	
	  //error checking
	  #ifndef MX_PWM
	  		#ifdef _BOOSTC
	  			#pragma error "This chip does not have PWM capability"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error This chip does not have PWM capability
			#endif
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccpr1l = nDuty;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccpr2l = nDuty;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal)
{
	
	  //error checking
	  #ifndef MX_PWM
	  		#ifdef _BOOSTC
	  			#pragma error "This chip does not have PWM capability"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error This chip does not have PWM capability
			#endif
	  #endif

	  #ifdef MX_PWM
	    pr2 = nPeriodVal;

	    switch (nPrescalerVal)
	    {
	        case 1:
	            t2con = 0x04;
	            break;

	        case 4:
	            t2con = 0x05;
	            break;

	        case 16:
	            t2con = 0x06;
	            break;
	    }
	  #endif

}

void FCD_PWM0_SetDutyCycle10bit(char nIdx, short nDuty)
{
	
		char nCCPxCONtemp;

	  //error checking
	  #ifndef MX_PWM
	  		#ifdef _BOOSTC
	  			#pragma error "This chip does not have PWM capability"
	  		#endif
	  		#ifdef HI_TECH_C
	  			#error This chip does not have PWM capability
			#endif
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccpr1l = (nDuty & 0x3FC) >> 2;

	    	nDuty = (nDuty & 0x03) << 4;
	    	nCCPxCONtemp = (ccp1con & 0xCF) | nDuty;
	    	ccp1con = nCCPxCONtemp;
	    }

	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccpr2l = (nDuty & 0x3FC) >> 2;

	    	nDuty = (nDuty & 0x03) << 4;
	    	nCCPxCONtemp = (ccp2con & 0xCF) | nDuty;
	    	ccp2con = nCCPxCONtemp;
	    }

	  #endif
	 #endif

}

//Macro implementations

void FCM_3_AND()
{
	
	//Repeat
	//Loop: While 1
	while (1)
	{
		//Test switches
		//Input: A0 -> switches
		trisa = trisa | 0x01;
		FCV_SWITCHES = ((porta & 0x01) == 0x01);


		//switch 1 on?
		//Decision: switches?
		if (FCV_SWITCHES)
		{
			//Test switches
			//Input: C1 -> switches
			trisc = trisc | 0x02;
			FCV_SWITCHES = ((portc & 0x02) == 0x02);


			//switch 1 on?
			//Decision: switches?
			if (FCV_SWITCHES)
			{
				//Read light level
				//Call Component Macro: light=ADC(1)::ReadAsByte
				FCV_LIGHT = FCD_ADC1_ReadAsByte();


				//Is it dark?
				//Decision: light<127?
				if (FCV_LIGHT<127)
				{
					//Switch on LED
					//Output: 1 -> C2
					trisc = trisc & 0xfb;
					if (1)
						portc = (portc & 0xfb) | 0x04;
					else
						portc = portc & 0xfb;


				} else {
					//Switch off LED
					//Output: 0 -> C2
					trisc = trisc & 0xfb;
					if (0)
						portc = (portc & 0xfb) | 0x04;
					else
						portc = portc & 0xfb;


				}


			} else {
				//Switch off LED
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			}


		} else {
			//Switch off LED
			//Output: 0 -> C2
			trisc = trisc & 0xfb;
			if (0)
				portc = (portc & 0xfb) | 0x04;
			else
				portc = portc & 0xfb;


		}


	}


}

void FCM_Car_Alarm()
{
	
	//Loop
	//Loop: While 1
	while (1)
	{
		//Calculation
		//Calculation:
		//  count = 0
		FCV_COUNT = 0;
		

		//Connection Point
		//Connection Point: [A]: A
FCC_Car_Alarm_A:
;


		//Read switch
		//Input: A1 -> switch
		trisa = trisa | 0x02;
		FCV_SWITCH = ((porta & 0x02) == 0x02);


		//Start?
		//Decision: switch?
		if (FCV_SWITCH)
		{
			//Switch on delay
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Check pulser time
			//Loop: While count < 20
			while (FCV_COUNT < 20)
			{
				//Switch on pulser
				//Output: 1 -> C2
				trisc = trisc & 0xfb;
				if (1)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


				//Delay
				//Delay: 500 ms
				delay_ms(255);
				delay_ms(245);


				//Switch off pulser
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


				//Delay
				//Delay: 500 ms
				delay_ms(255);
				delay_ms(245);


				//Check delay time
				//Decision: count = 3?
				if (FCV_COUNT == 3)
				{
					//Switch off delay
					//Output: 0 -> C1
					trisc = trisc & 0xfd;
					if (0)
						portc = (portc & 0xfd) | 0x02;
					else
						portc = portc & 0xfd;


				}


				//Increase count
				//Calculation:
				//  count = count+1
				FCV_COUNT = FCV_COUNT+1;
				

			}


		} else {
			//Goto Connection Point
			//Goto Connection Point: [A]: A
			goto FCC_Car_Alarm_A;


		}


	}


}

void FCM_Motor()
{
	
	//Read the temperature
	//Call Component Macro: offset=ADC(0)::ReadAsByte
	FCV_OFFSET = FCD_ADC0_ReadAsByte();


	//Turn on the output
	//Call Component Macro: PWM(0)::Enable(1)
	FCD_PWM0_Enable(1);


	//Repeat
	//Loop: While 1
	while (1)
	{
		//Read the temperature
		//Call Component Macro: temp=ADC(0)::ReadAsByte
		FCV_TEMP = FCD_ADC0_ReadAsByte();


		//Decision
		//Decision: temp > offset?
		if (FCV_TEMP > FCV_OFFSET)
		{
			//Calculation
			//Calculation:
			//  temp = temp - offset
			//  temp = temp * 5
			FCV_TEMP = FCV_TEMP - FCV_OFFSET;
			FCV_TEMP = FCV_TEMP * 5;
			

		}


		//Decision
		//Decision: temp > 255?
		if (FCV_TEMP > 255)
		{
			//Calculation
			//Calculation:
			//  temp = 255
			FCV_TEMP = 255;
			

		}


		//Set the motor speed
		//Call Component Macro: PWM(0)::SetDutyCycle(1, temp)
		FCD_PWM0_SetDutyCycle(1, FCV_TEMP);


	}


}

void FCM_Programmable_Logic()
{
	
	//Repeat
	//Loop: While 1
	while (1)
	{
		//Check master switch
		//Input: A1 -> Master
		trisa = trisa | 0x02;
		FCV_MASTER = ((porta & 0x02) == 0x02);


		//Read switch A
		//Input: A0 -> A
		trisa = trisa | 0x01;
		FCV_A = ((porta & 0x01) == 0x01);


		//Read switch C
		//Input: C1 -> C
		trisc = trisc | 0x02;
		FCV_C = ((portc & 0x02) == 0x02);


		//Select security level
		//Decision: Master=1?
		if (FCV_MASTER==1)
		{
			//OR gate
			//Calculation:
			//  Switch1 = C OR A
			FCV_SWITCH1 = FCV_C | FCV_A;
			

			//Decision
			//Decision: Switch1 = 1?
			if (FCV_SWITCH1 == 1)
			{
				//Open
				//Output: 1 -> C2
				trisc = trisc & 0xfb;
				if (1)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			} else {
				//Close
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			}


		} else {
			//AND gate
			//Calculation:
			//  Switch1 = C AND A
			FCV_SWITCH1 = FCV_C & FCV_A;
			

			//AND gate
			//Decision: Switch1=1?
			if (FCV_SWITCH1==1)
			{
				//Open
				//Output: 1 -> C2
				trisc = trisc & 0xfb;
				if (1)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			} else {
				//Close
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			}


		}


	}


}

void FCM_Sequence_Generator()
{
	
	//Loop
	//Loop: While 1
	while (1)
	{
		//Read speed setting
		//Call Component Macro: speed=ADC(0)::ReadAsByte
		FCV_SPEED = FCD_ADC0_ReadAsByte();


		//Decision
		//Decision: speed<10?
		if (FCV_SPEED<10)
		{
		} else {
			//Switch on LED 1
			//Output: 1 -> A1
			trisa = trisa & 0xfd;
			if (1)
				porta = (porta & 0xfd) | 0x02;
			else
				porta = porta & 0xfd;


			//Wait
			//Delay: speed ms
			delay_ms(FCV_SPEED);


			//Switch off LED 1
			//Output: 0 -> A1
			trisa = trisa & 0xfd;
			if (0)
				porta = (porta & 0xfd) | 0x02;
			else
				porta = porta & 0xfd;


			//Switch on LED 2
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Wait
			//Delay: speed ms
			delay_ms(FCV_SPEED);


			//Switch off LED 2
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Switch on LED 3
			//Output: 1 -> C2
			trisc = trisc & 0xfb;
			if (1)
				portc = (portc & 0xfb) | 0x04;
			else
				portc = portc & 0xfb;


			//Wait
			//Delay: speed ms
			delay_ms(FCV_SPEED);


			//Switch off LED 3
			//Output: 0 -> C2
			trisc = trisc & 0xfb;
			if (0)
				portc = (portc & 0xfb) | 0x04;
			else
				portc = portc & 0xfb;


		}


	}


}

void FCM_Thermistor()
{
	
	//Read base temperature
	//Call Component Macro: temp2=ADC(1)::ReadAsByte
	FCV_TEMP2 = FCD_ADC1_ReadAsByte();


	//Loop
	//Loop: While 1
	while (1)
	{
		//Read current temperature
		//Call Component Macro: temp3=ADC(1)::ReadAsByte
		FCV_TEMP3 = FCD_ADC1_ReadAsByte();


		//Warm?
		//Decision: temp3 > temp2 + 8?
		if (FCV_TEMP3 > FCV_TEMP2 + 8)
		{
			//Hot?
			//Decision: temp3 > temp2 + 11?
			if (FCV_TEMP3 > FCV_TEMP2 + 11)
			{
				//Switch off green
				//Output: 0 -> A0
				trisa = trisa & 0xfe;
				if (0)
					porta = (porta & 0xfe) | 0x01;
				else
					porta = porta & 0xfe;


				//Switch off amber
				//Output: 0 -> C1
				trisc = trisc & 0xfd;
				if (0)
					portc = (portc & 0xfd) | 0x02;
				else
					portc = portc & 0xfd;


				//Switch on red
				//Output: 1 -> C2
				trisc = trisc & 0xfb;
				if (1)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			} else {
				//Switch off green
				//Output: 0 -> A0
				trisa = trisa & 0xfe;
				if (0)
					porta = (porta & 0xfe) | 0x01;
				else
					porta = porta & 0xfe;


				//Switch on amber
				//Output: 1 -> C1
				trisc = trisc & 0xfd;
				if (1)
					portc = (portc & 0xfd) | 0x02;
				else
					portc = portc & 0xfd;


				//Switch off red
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			}


		} else {
			//Switch on green
			//Output: 1 -> A0
			trisa = trisa & 0xfe;
			if (1)
				porta = (porta & 0xfe) | 0x01;
			else
				porta = porta & 0xfe;


			//Switch off amber
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Switch off red
			//Output: 0 -> C2
			trisc = trisc & 0xfb;
			if (0)
				portc = (portc & 0xfb) | 0x04;
			else
				portc = portc & 0xfb;


		}


	}


}

void FCM_Timer()
{
	
	//Test switches
	//Input: PORT A -> switch
	trisa = trisa | 0x02;
	FCV_SWITCH = porta & 0x02;


	//Decision
	//Decision: switch?
	if (FCV_SWITCH)
	{
		//Calculation
		//Calculation:
		//  switches = 0x02
		FCV_SWITCHES = 0x02;
		

	} else {
		//Calculation
		//Calculation:
		//  switches = 0
		FCV_SWITCHES = 0;
		

	}


	//Test switches
	//Input: PORT C -> switch
	trisc = trisc | 0x04;
	FCV_SWITCH = portc & 0x04;


	//Decision
	//Decision: switch?
	if (FCV_SWITCH)
	{
		//Calculation
		//Calculation:
		//  switches = switches | 0x04
		FCV_SWITCHES = FCV_SWITCHES | 0x04;
		

	}


	//Switch
	//Switch: switches?
	switch (FCV_SWITCHES)
	{
		case 2:
		{
			//Switch on output
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Delay
			//Delay: 5 s
			delay_s(5);


			//Switch off output
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			break;
		}

		case 4:
		{
			//Switch on output
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Delay
			//Delay: 10 s
			delay_s(10);


			//Switch off output
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			break;
		}

		case 6:
		{
			//Switch on output
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Delay
			//Delay: 15 s
			delay_s(15);


			//Switch off output
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			break;
		}

		default:
		{
			//Read delay
			//Call Component Macro: var=ADC(0)::ReadAsByte
			FCV_VAR = FCD_ADC0_ReadAsByte();


			//Calculation
			//Calculation:
			//  var = var/10
			FCV_VAR = FCV_VAR/10;
			

			//Switch on output
			//Output: 1 -> C1
			trisc = trisc & 0xfd;
			if (1)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


			//Delay
			//Delay: var s
			delay_s(FCV_VAR);


			//Switch off output
			//Output: 0 -> C1
			trisc = trisc & 0xfd;
			if (0)
				portc = (portc & 0xfd) | 0x02;
			else
				portc = portc & 0xfd;


		}
	}


}

void FCM_Waveform_Generator()
{
	
	//Reset outputs
	//Output: 0 -> PORT A
	trisa = trisa & 0xfc;
	porta = (porta & 0xfc) | (0 & 0x03);


	//Reset outputs
	//Output: 0 -> PORT C
	trisc = 0x00;
	portc = 0;


	//Loop
	//Loop: While 1
	while (1)
	{
		//Calculation
		//Calculation:
		//  count = count + 1
		FCV_COUNT = FCV_COUNT + 1;
		

		//Calculation
		//Calculation:
		//  var = count MOD 5
		FCV_VAR = FCV_COUNT % 5;
		

		//Decision
		//Decision: var = 0?
		if (FCV_VAR == 0)
		{
			//Decision
			//Decision: A?
			if (FCV_A)
			{
				//Calculation
				//Calculation:
				//  A = 0
				FCV_A = 0;
				

				//Output
				//Output: 0 -> A0
				trisa = trisa & 0xfe;
				if (0)
					porta = (porta & 0xfe) | 0x01;
				else
					porta = porta & 0xfe;


			} else {
				//Calculation
				//Calculation:
				//  A = 1
				FCV_A = 1;
				

				//Output
				//Output: 1 -> A0
				trisa = trisa & 0xfe;
				if (1)
					porta = (porta & 0xfe) | 0x01;
				else
					porta = porta & 0xfe;


			}


		}


		//Calculation
		//Calculation:
		//  var = count MOD 10
		FCV_VAR = FCV_COUNT % 10;
		

		//Decision
		//Decision: var = 0?
		if (FCV_VAR == 0)
		{
			//Decision
			//Decision: B?
			if (FCV_B)
			{
				//Calculation
				//Calculation:
				//  B = 0
				FCV_B = 0;
				

				//Output
				//Output: 0 -> A1
				trisa = trisa & 0xfd;
				if (0)
					porta = (porta & 0xfd) | 0x02;
				else
					porta = porta & 0xfd;


			} else {
				//Calculation
				//Calculation:
				//  B = 1
				FCV_B = 1;
				

				//Output
				//Output: 1 -> A1
				trisa = trisa & 0xfd;
				if (1)
					porta = (porta & 0xfd) | 0x02;
				else
					porta = porta & 0xfd;


			}


		}


		//Calculation
		//Calculation:
		//  var = count MOD 20
		FCV_VAR = FCV_COUNT % 20;
		

		//Decision
		//Decision: var = 0?
		if (FCV_VAR == 0)
		{
			//Decision
			//Decision: C?
			if (FCV_C)
			{
				//Calculation
				//Calculation:
				//  C = 0
				FCV_C = 0;
				

				//Output
				//Output: 0 -> C1
				trisc = trisc & 0xfd;
				if (0)
					portc = (portc & 0xfd) | 0x02;
				else
					portc = portc & 0xfd;


			} else {
				//Calculation
				//Calculation:
				//  C = 1
				FCV_C = 1;
				

				//Output
				//Output: 1 -> C1
				trisc = trisc & 0xfd;
				if (1)
					portc = (portc & 0xfd) | 0x02;
				else
					portc = portc & 0xfd;


			}


		}


		//Calculation
		//Calculation:
		//  var = count MOD 40
		FCV_VAR = FCV_COUNT % 40;
		

		//Decision
		//Decision: var = 0?
		if (FCV_VAR == 0)
		{
			//Calculation
			//Calculation:
			//  count = 0
			FCV_COUNT = 0;
			

			//Decision
			//Decision: D?
			if (FCV_D)
			{
				//Calculation
				//Calculation:
				//  D = 0
				FCV_D = 0;
				

				//Output
				//Output: 0 -> C2
				trisc = trisc & 0xfb;
				if (0)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			} else {
				//Calculation
				//Calculation:
				//  D = 1
				FCV_D = 1;
				

				//Output
				//Output: 1 -> C2
				trisc = trisc & 0xfb;
				if (1)
					portc = (portc & 0xfb) | 0x04;
				else
					portc = portc & 0xfb;


			}


		}


		//Delay
		//Delay: 50 ms
		delay_ms(50);


	}


}

void FCM_Program_Mode()
{
	
	//Comment:
	//Allow Switch values
	//to stabilise


	//Delay
	//Delay: 1 ms
	delay_ms(1);


	//Input
	//Input: B0 -> b0
	trisb = trisb | 0x01;
	FCV_B0 = ((portb & 0x01) == 0x01);


	//Input
	//Input: B1 -> b1
	trisb = trisb | 0x02;
	FCV_B1 = ((portb & 0x02) == 0x02);


	//Input
	//Input: B2 -> b2
	trisb = trisb | 0x04;
	FCV_B2 = ((portb & 0x04) == 0x04);


	//Calculation
	//Calculation:
	//  MODE = b2
	//  MODE = MODE | (b1 << 1)
	//  MODE = MODE | (b0 << 2)
	FCV_MODE = FCV_B2;
	FCV_MODE = FCV_MODE | (FCV_B1 << 1);
	FCV_MODE = FCV_MODE | (FCV_B0 << 2);
	

}

void FCM_LED_Flash()
{
	
	//Loop
	//Loop: Loop 3 times
	for (FCLV_LOOP1=0; FCLV_LOOP1<3; FCLV_LOOP1++)
	{
		//Switch on LED
		//Output: 1 -> A4
		trisa = trisa & 0xef;
		if (1)
			porta = (porta & 0xef) | 0x10;
		else
			porta = porta & 0xef;


		//Delay
		//Delay: 200 ms
		delay_ms(200);


		//Output
		//Output: 0 -> A4
		trisa = trisa & 0xef;
		if (0)
			porta = (porta & 0xef) | 0x10;
		else
			porta = porta & 0xef;


		//Delay
		//Delay: 200 ms
		delay_ms(200);


	}


}

void main()
{
	
	//Initialisation
	adcon1 = 0x0F;
	ucfg = 0x08;
cr_bit(pie2, USBIE);


	//Interrupt initialisation code
	


	//Call Macro
	//Call Macro: LED_Flash
	FCM_LED_Flash();


	//Start
	//Connection Point: [A]: A
FCC_Main_A:
;


	//Read Program Mode
	//Call Macro: Program_Mode
	FCM_Program_Mode();


	//Switch on LED
	//Output: 1 -> A4
	trisa = trisa & 0xef;
	if (1)
		porta = (porta & 0xef) | 0x10;
	else
		porta = porta & 0xef;


	//Jump to sub Program
	//Switch: MODE?
	switch (FCV_MODE)
	{
		case 0:
		{
			//Prog0
			//Call Macro: 3_AND
			FCM_3_AND();


			break;
		}

		case 1:
		{
			//Prog1
			//Call Macro: Programmable_Logic
			FCM_Programmable_Logic();


			break;
		}

		case 2:
		{
			//Prog2
			//Call Macro: Thermistor
			FCM_Thermistor();


			break;
		}

		case 3:
		{
			//Prog3
			//Call Macro: Motor
			FCM_Motor();


			break;
		}

		case 4:
		{
			//Prog4
			//Call Macro: Car_Alarm
			FCM_Car_Alarm();


			break;
		}

		case 5:
		{
			//Prog5
			//Call Macro: Sequence_Generator
			FCM_Sequence_Generator();


			break;
		}

		case 6:
		{
			//Prog6
			//Call Macro: Timer
			FCM_Timer();


			break;
		}

		case 7:
		{
			//Prog7
			//Call Macro: Waveform_Generator
			FCM_Waveform_Generator();


			break;
		}

		default:
		{
			//Jump to start
			//Goto Connection Point: [A]: A
			goto FCC_Main_A;


		}
	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
}



